<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
-->

<script setup lang="ts">
import { Ref, onMounted, ref } from 'vue';
import { useRoute } from 'vue-router/composables';
import * as api from '../api';
import * as util from '../util';
import * as entities from '../entities';

const checking = ref(true);
const loading = ref(false);
const success = ref(false);
const route = useRoute();
const token: Ref<entities.PasswordReset | undefined> = ref(undefined);
const password1 = ref('');
const password2 = ref('');
const error: Ref<string[]> = ref([]);

onMounted(() => {
  const getPasswordReset = api.forgot.getPasswordReset(route.params.token);

  getPasswordReset.then((data) => (token.value = data));
  api.allCatching([getPasswordReset]).finally(() => (checking.value = false));
});

function doReset() {
  loading.value = true;

  const executePasswordReset = api.forgot.executePasswordReset(route.params.token, password2.value);

  executePasswordReset.then((data) => {
    switch (data.state) {
      case 'success': {
        success.value = true;
        break;
      }
      case 'token_not_found': {
        token.value = undefined;
        break;
      }
      case 'error': {
        error.value = data.messages;
      }
    }
  });
  api.allCatching([executePasswordReset]).finally(() => (loading.value = false));
}
</script>

<template>
  <div v-if="!checking">
    <v-alert type="warning" v-if="!token">
      Das Token konnte nicht gefunden werden, eventuell wurde es bereits benutzt oder ist
      abgelaufen.
    </v-alert>

    <v-alert type="success" v-if="success">
      Passwort erfolgreich geändert, du kannst dich jetzt mit deinem neuen Passwort anmelden.
    </v-alert>

    <v-form ref="form" v-on:submit.prevent="doReset">
      <v-card-text v-if="token && !success">
        <v-alert type="warning" v-if="error.length > 0">
          Bitte folgende Fehler beheben:
          <ul>
            <li v-for="e in error" :key="e">
              {{ e }}
            </li>
          </ul>
        </v-alert>

        <p>
          Passwort für {{ token.user.firstname }} {{ token.user.surname }} &lt;{{
            token.user.mail
          }}&gt; ({{ token.user.username }}) ändern:
        </p>

        <v-text-field
          label="Passwort"
          name="password1"
          type="password"
          prepend-icon="mdi-lock"
          v-model="password1"
          :disabled="loading"
          :rules="[util.validatePassword]"
        />

        <v-text-field
          label="Passwort wiederholen"
          name="password2"
          prepend-icon="mdi-lock"
          type="password"
          v-model="password2"
          :rules="[util.validatePassword, util.validatePasswordsEqual(password1, password2)]"
          :disabled="loading"
        />
      </v-card-text>
      <v-card-actions>
        <router-link class="deep-orange--text" to="/login" v-if="!loading"
          >&lt; Zurück zum Login</router-link
        >
        <v-spacer />
        <router-link class="deep-orange--text" to="/forgot" v-if="!token && !success"
          >Neues Token anfordern &gt;</router-link
        >
        <v-btn
          color="orange darken-2"
          class="pa-4 white--text"
          tile
          :loading="loading"
          :disabled="loading"
          v-if="token && !success"
          type="submit"
          >Passwort setzen</v-btn
        >
      </v-card-actions>
    </v-form>
  </div>
  <div class="text-center" v-else>
    <v-progress-circular indeterminate color="primary"></v-progress-circular>
  </div>
</template>
